-- FS25_MonumentRestoration/scripts/BankManager.lua

BankManager = {}
BankManager.accounts = {}

function BankManager.init()
    if g_server then
        g_messageCenter:subscribe(MessageType.DAY_CHANGED, BankManager.onDayChanged, BankManager)
        print("[BankManager] Подписан на событие DAY_CHANGED")
    end
end

function BankManager.registerAccount(account)
    table.insert(BankManager.accounts, account)
    print("[BankManager] Зарегистрирован банковский счёт: " .. tostring(account) .. ", Всего счетов: " .. #BankManager.accounts)
end

function BankManager.unregisterAccount(account)
    for i, acc in ipairs(BankManager.accounts) do
        if acc == account then
            table.remove(BankManager.accounts, i)
            print("[BankManager] Удалён банковский счёт: " .. tostring(account) .. ", Всего счетов: " .. #BankManager.accounts)
            break
        end
    end
end

function BankManager.onDayChanged()
    print("[BankManager] Смена дня, начисление процентов для " .. #BankManager.accounts .. " счетов")
    for _, account in ipairs(BankManager.accounts) do
        if account.accrueInterest then
            account:accrueInterest()
        else
            print("[BankManager] Предупреждение: Счёт " .. tostring(account) .. " не имеет метода accrueInterest")
        end
    end
end

-- Инициализация при старте игры
BankManager.init()